;******************************************************************************
;* TMS320C6x C/C++ Codegen                                        Unix v7.4.5 *
;* Date/Time created: Mon Oct 28 01:37:57 2013                                *
;******************************************************************************
	.compiler_opts --abi=coffabi --c64p_l1d_workaround=default --endian=little --hll_source=on --long_precision_bits=40 --mem_model:code=near --mem_model:const=far --mem_model:data=far --object_format=coff --silicon_version=6500 --symdebug:none 

;******************************************************************************
;* GLOBAL FILE PARAMETERS                                                     *
;*                                                                            *
;*   Architecture      : TMS320C64x+                                          *
;*   Optimization      : Enabled at level 3                                   *
;*   Optimizing for    : Speed                                                *
;*                       Based on options: -o3, no -ms                        *
;*   Endian            : Little                                               *
;*   Interrupt Thrshld : Disabled                                             *
;*   Data Access Model : Far                                                  *
;*   Pipelining        : Enabled                                              *
;*   Speculate Loads   : Enabled with threshold = 0                           *
;*   Memory Aliases    : Presume are aliases (pessimistic)                    *
;*   Debug Info        : No Debug Info                                        *
;*                                                                            *
;******************************************************************************

	.asg	A15, FP
	.asg	B14, DP
	.asg	B15, SP
	.global	$bss

;*****************************************************************************
;* CINIT RECORDS                                                             *
;*****************************************************************************
	.sect	".cinit"
	.align	8
	.field  	$C$IR_1,32
	.field  	_component_dsprite+0,32
	.bits	0,32			; _component_dsprite._fxns._init @ 0
	.bits	_loc_exec,32		; _component_dsprite._fxns._exec @ 32
	.bits	0,32			; _component_dsprite._fxns._exec_fc @ 64
	.bits	0,32			; _component_dsprite._fxns._exit @ 96
	.bits	100,8			; _component_dsprite._name[0] @ 128
	.bits	115,8			; _component_dsprite._name[1] @ 136
	.bits	112,8			; _component_dsprite._name[2] @ 144
	.bits	114,8			; _component_dsprite._name[3] @ 152
	.bits	105,8			; _component_dsprite._name[4] @ 160
	.bits	116,8			; _component_dsprite._name[5] @ 168
	.bits	101,8			; _component_dsprite._name[6] @ 176
	.bits	0,8			; _component_dsprite._name[7] @ 184
$C$IR_1:	.set	24

	.global	_syscalls
_syscalls:	.usect	".sec_mlb_syscalls",208,4
	.global	_xxx
_xxx:	.usect	".far",4,4
	.global	_component_dsprite
_component_dsprite:	.usect	".sec_com",52,4
;	opt6x /tmp/04725xlWKvd /tmp/04725pq75ck 
	.sect	".text"
	.clink
	.global	_main

;******************************************************************************
;* FUNCTION NAME: main                                                        *
;*                                                                            *
;*   Regs Modified     :                                                      *
;*   Regs Used         : B3                                                   *
;*   Local Frame Size  : 0 Args + 0 Auto + 0 Save = 0 byte                    *
;******************************************************************************
_main:
;** --------------------------------------------------------------------------*
;**  	-----------------------    return;
           RETNOP  .S2     B3,5              ; |593| 
           ; BRANCH OCCURS {B3}              ; |593| 
	.sect	".text"
	.clink

;******************************************************************************
;* FUNCTION NAME: loc_multi_srcover_argb32                                    *
;*                                                                            *
;*   Regs Modified     : A0,A1,A3,A4,A5,A6,A7,A8,A9,B4,B5,B6,B7,B8,B9,A16,A17,*
;*                           B16,B17,B18                                      *
;*   Regs Used         : A0,A1,A3,A4,A5,A6,A7,A8,A9,B3,B4,B5,B6,B7,B8,B9,DP,  *
;*                           SP,A16,A17,B16,B17,B18                           *
;*   Local Frame Size  : 0 Args + 0 Auto + 0 Save = 0 byte                    *
;******************************************************************************
_loc_multi_srcover_argb32:
;** --------------------------------------------------------------------------*
;** 179	-----------------------    if ( !((_d-_s < 132)&(_s-_d < 132)) ) goto g4;
;**  	-----------------------    U$18 = _s;
;**  	-----------------------    U$21 = _d;
;**  	-----------------------    L$1 = _num;
;**  	-----------------------    #pragma MUST_ITERATE(64, 1024, 8)
;**  	-----------------------    #pragma LOOP_FLAGS(4104u)

           MVK     .S2     132,B5            ; |179| 
||         SUB     .L2X    A4,B4,B6          ; |179| 
||         MVK     .S1     132,A5            ; |179| 
||         SUB     .L1X    B4,A4,A3          ; |179| 
||         MV      .D1     A6,A0             ; |165| 

           MV      .L1X    B4,A7             ; |165| 
||         MV      .S2X    A4,B7             ; |165| 
||         CMPLT   .L2     B6,B5,B5          ; |179| 

           CMPLT   .L1     A3,A5,A3          ; |179| 
           AND     .L1X    B5,A3,A1          ; |179| 

   [!A1]   BNOP    .S1     $C$L4,5           ; |179| 
|| [!A1]   SUB     .L1     A6,1,A17

           ; BRANCHCC OCCURS {$C$L4}         ; |179| 
;** --------------------------------------------------------------------------*
;**	-----------------------g3:
;** 198	-----------------------    C$13 = *U$21;
;** 198	-----------------------    C$16 = _extu(C$13, 24u, 24u);
;** 198	-----------------------    C$11 = *U$18++;
;** 198	-----------------------    C$15 = C$11>>24;
;** 198	-----------------------    C$10 = (C$15&1u)+C$15;
;** 198	-----------------------    C$14 = _extu(C$13, 16u, 24u);
;** 198	-----------------------    C$12 = _extu(C$13, 8u, 24u);
;** 198	-----------------------    *U$21++ = (unsigned)(((int)(unsigned char)((_mpyus(C$10, _extu(C$11, 8u, 24u)-C$12)>>8)+C$12)<<8|(unsigned char)((_mpyus(C$10, _extu(C$11, 16u, 24u)-C$14)>>8)+C$14))<<8)|(unsigned)(unsigned char)((_mpyus(C$10, _extu(C$11, 24u, 24u)-C$16)>>8)+C$16);
;** 175	-----------------------    if ( L$1 = L$1-1 ) goto g3;

           LDW     .D1T1   *A7,A6            ; |198| (P) <0,0> 
||         SUB     .L1     A0,2,A0
||         DINT                              ; interrupts off

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop found in file               : dsprite.c
;*      Loop source line                 : 175
;*      Loop opening brace source line   : 176
;*      Loop closing brace source line   : 206
;*      Known Minimum Trip Count         : 64                    
;*      Known Maximum Trip Count         : 1024                    
;*      Known Max Trip Count Factor      : 8
;*      Loop Carried Dependency Bound(^) : 17
;*      Unpartitioned Resource Bound     : 8
;*      Partitioned Resource Bound(*)    : 8
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     7        8*    
;*      .D units                     2        1     
;*      .M units                     1        2     
;*      .X cross paths               2        5     
;*      .T address paths             1        2     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        2     (.L or .S unit)
;*      Addition ops (.LSD)          3        6     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             4        5     
;*      Bound(.L .S .D .LS .LSD)     4        6     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 17 Did not find schedule
;*         ii = 18 Schedule found with 2 iterations in parallel
;*      Done
;*
;*      Epilog not removed
;*      Collapsed epilog stages       : 0
;*
;*      Prolog not removed
;*      Collapsed prolog stages       : 0
;*
;*      Minimum required memory pad   : 0 bytes
;*
;*      For further improvement on this loop, try option -mh4
;*
;*      Minimum safe trip count       : 2
;*----------------------------------------------------------------------------*
$C$L1:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
$C$L2:    ; PIPED LOOP KERNEL
           LDW     .D2T2   *B7++,B4          ; |198| <0,2>  ^ 
           NOP             3
           EXTU    .S1     A6,24,24,A4       ; |198| <0,6> 

           MV      .L1X    B4,A3             ; |198| <0,7> Define a twin register
||         SHRU    .S2     B4,24,B8          ; |198| <0,7>  ^ 
||         EXTU    .S1     A6,16,24,A5       ; |198| <0,7> 

           EXTU    .S2     B4,16,24,B5       ; |198| <0,8> 
||         AND     .L2     1,B8,B6           ; |198| <0,8>  ^ 
||         EXTU    .S1     A6,8,24,A6        ; |198| <0,8> 

           EXTU    .S2     B4,8,24,B6        ; |198| <0,9> 
||         EXTU    .S1     A3,24,24,A3       ; |198| <0,9> 
||         ADD     .D2     B8,B6,B4          ; |198| <0,9>  ^ 
||         SUB     .L2X    B5,A5,B5          ; |198| <0,9> 

           SUB     .L1     A3,A4,A3          ; |198| <0,10> 
||         MPYUS   .M2     B4,B5,B4          ; |198| <0,10>  ^ 
||         SUB     .L2X    B6,A6,B5          ; |198| <0,10> 

           MPYUS   .M1X    B4,A3,A3          ; |198| <0,11>  ^ 
||         MPYUS   .M2     B4,B5,B4          ; |198| <0,11>  ^ 

           SHR     .S2     B4,8,B5           ; |198| <0,12>  ^ 

           ADD     .L2X    A5,B5,B5          ; |198| <0,13>  ^ 
||         SHR     .S1     A3,8,A3           ; |198| <0,13>  ^ 
||         SHR     .S2     B4,8,B4           ; |198| <0,13>  ^ 

           ADD     .L1     A4,A3,A3          ; |198| <0,14>  ^ 
||         EXTU    .S2     B5,24,24,B5       ; |198| <0,14>  ^ 
|| [ A0]   BDEC    .S1     $C$L2,A0          ; |175| <0,14> 
||         ADD     .L2X    A6,B4,B4          ; |198| <0,14>  ^ 

           EXTU    .S1     A3,24,24,A3       ; |198| <0,15>  ^ 
||         EXTU    .S2     B4,24,16,B4       ; |198| <0,15>  ^ 

           OR      .L2     B5,B4,B4          ; |198| <0,16>  ^ 
           SHL     .S2     B4,8,B4           ; |198| <0,17>  ^ 

           OR      .L2X    A3,B4,B4          ; |198| <0,18>  ^ 
||         LDW     .D1T1   *+A7(4),A6        ; |198| <1,0> 

           STW     .D1T2   B4,*A7++          ; |198| <0,19>  ^ 
;** --------------------------------------------------------------------------*
$C$L3:    ; PIPED LOOP EPILOG
;** 175	-----------------------    goto g6;
;**	-----------------------g4:
;**  	-----------------------    U$18 = _s;
;**  	-----------------------    U$21 = _d;
;**  	-----------------------    L$2 = _num;
;**  	-----------------------    #pragma[60] (_s != _d;)
;**  	-----------------------    #pragma MUST_ITERATE(64, 1024, 8)
;**  	-----------------------    #pragma LOOP_FLAGS(4160u)
           LDW     .D2T2   *B7++,B6          ; |198| (E) <1,2>  ^ 
           NOP             3
           EXTU    .S1     A6,24,24,A4       ; |198| (E) <1,6> 

           MV      .L1X    B6,A8             ; |198| (E) <1,7> Define a twin register
||         SHRU    .S2     B6,24,B8          ; |198| (E) <1,7>  ^ 
||         EXTU    .S1     A6,16,24,A5       ; |198| (E) <1,7> 

           EXTU    .S2     B6,16,24,B5       ; |198| (E) <1,8> 
||         AND     .L2     1,B8,B4           ; |198| (E) <1,8>  ^ 
||         EXTU    .S1     A6,8,24,A3        ; |198| (E) <1,8> 

           EXTU    .S2     B6,8,24,B4        ; |198| (E) <1,9> 
||         EXTU    .S1     A8,24,24,A6       ; |198| (E) <1,9> 
||         ADD     .D2     B8,B4,B6          ; |198| (E) <1,9>  ^ 
||         SUB     .L2X    B5,A5,B5          ; |198| (E) <1,9> 

           SUB     .L1     A6,A4,A6          ; |198| (E) <1,10> 
||         MPYUS   .M2     B6,B5,B4          ; |198| (E) <1,10>  ^ 
||         SUB     .L2X    B4,A3,B4          ; |198| (E) <1,10> 

           MPYUS   .M1X    B6,A6,A6          ; |198| (E) <1,11>  ^ 
||         MPYUS   .M2     B6,B4,B5          ; |198| (E) <1,11>  ^ 

;** --------------------------------------------------------------------------*
;**	-----------------------g5:
;** 198	-----------------------    C$6 = *U$21;
;** 198	-----------------------    C$9 = _extu(C$6, 24u, 24u);
;** 198	-----------------------    C$4 = *U$18++;
;** 198	-----------------------    C$8 = C$4>>24;
;** 198	-----------------------    C$3 = (C$8&1u)+C$8;
;** 198	-----------------------    C$7 = _extu(C$6, 16u, 24u);
;** 198	-----------------------    C$5 = _extu(C$6, 8u, 24u);
;** 198	-----------------------    *U$21++ = (unsigned)(((int)(unsigned char)((_mpyus(C$3, _extu(C$4, 8u, 24u)-C$5)>>8)+C$5)<<8|(unsigned char)((_mpyus(C$3, _extu(C$4, 16u, 24u)-C$7)>>8)+C$7))<<8)|(unsigned)(unsigned char)((_mpyus(C$3, _extu(C$4, 24u, 24u)-C$9)>>8)+C$9);
;** 175	-----------------------    if ( L$2 = L$2-1 ) goto g5;
;**	-----------------------g6:
;**  	-----------------------    return;
           SHR     .S2     B4,8,B4           ; |198| (E) <1,12>  ^ 
           SHR     .S2     B5,8,B5           ; |198| (E) <1,13>  ^ 
           ADD     .L2X    A3,B5,B5          ; |198| (E) <1,14>  ^ 
           EXTU    .S2     B5,24,16,B5       ; |198| (E) <1,15>  ^ 

           ADD     .L2X    A5,B4,B4          ; |198| (E) <1,13>  ^ 
||         SHR     .S1     A6,8,A5           ; |198| (E) <1,13>  ^ 
||         RET     .S2     B3                ; |207| 

           ADD     .L1     A4,A5,A3          ; |198| (E) <1,14>  ^ 
||         EXTU    .S2     B4,24,24,B4       ; |198| (E) <1,14>  ^ 

           OR      .L2     B4,B5,B4          ; |198| (E) <1,16>  ^ 
||         EXTU    .S1     A3,24,24,A3       ; |198| (E) <1,15>  ^ 

           SHL     .S2     B4,8,B4           ; |198| (E) <1,17>  ^ 
           OR      .L2X    A3,B4,B4          ; |198| (E) <1,18>  ^ 

           STW     .D1T2   B4,*A7++          ; |198| (E) <1,19>  ^ 
||         RINT                              ; interrupts on

           ; BRANCH OCCURS {B3}              ; |207| 
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop found in file               : dsprite.c
;*      Loop source line                 : 175
;*      Loop opening brace source line   : 176
;*      Loop closing brace source line   : 206
;*      Known Minimum Trip Count         : 64                    
;*      Known Maximum Trip Count         : 1024                    
;*      Known Max Trip Count Factor      : 8
;*      Loop Carried Dependency Bound(^) : 7
;*      Unpartitioned Resource Bound     : 7
;*      Partitioned Resource Bound(*)    : 7
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     7*       7*    
;*      .D units                     1        2     
;*      .M units                     2        1     
;*      .X cross paths               4        5     
;*      .T address paths             1        2     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           2        1     (.L or .S unit)
;*      Addition ops (.LSD)          3        4     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             5        4     
;*      Bound(.L .S .D .LS .LSD)     5        5     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 7  Schedule found with 4 iterations in parallel
;*      Done
;*
;*      Loop will be splooped
;*      Collapsed epilog stages       : 0
;*      Collapsed prolog stages       : 0
;*      Minimum required memory pad   : 0 bytes
;*
;*      For further improvement on this loop, try option -mh4
;*
;*      Minimum safe trip count       : 1
;*----------------------------------------------------------------------------*
$C$L4:    ; PIPED LOOP PROLOG

           SPLOOPD 7       ;28               ; (P) 
||         MV      .L1     A4,A17
||         MVC     .S2X    A17,ILC

;** --------------------------------------------------------------------------*
$C$L5:    ; PIPED LOOP KERNEL
           LDW     .D1T1   *A17++,A9         ; |198| (P) <0,0> 
           NOP             3

           SPMASK          L2
||         MV      .L2     B4,B6

           LDW     .D2T2   *B6++,B8          ; |198| (P) <0,5> 
           SHRU    .S1     A9,24,A8          ; |198| (P) <0,6> 
           EXTU    .S1     A9,16,24,A4       ; |198| (P) <0,7> 
           AND     .L1     1,A8,A7           ; |198| (P) <0,8> 
           EXTU    .S1     A9,24,24,A6       ; |198| (P) <0,9> 

           ADD     .L1     A8,A7,A16         ; |198| (P) <0,10> 
||         EXTU    .S2     B8,8,24,B9        ; |198| (P) <0,10>  ^ 

           EXTU    .S1     A9,8,24,A5        ; |198| (P) <0,11> 
||         EXTU    .S2     B8,16,24,B7       ; |198| (P) <0,11> 

           SUB     .L1X    A5,B9,A4          ; |198| (P) <0,12>  ^ 
||         SUB     .L2X    A4,B7,B17         ; |198| (P) <0,12> 

           MPYUS   .M1     A16,A4,A3         ; |198| (P) <0,13>  ^ 

           EXTU    .S2     B8,24,24,B16      ; |198| (P) <0,14>  ^ 
||         MPYUS   .M2X    A16,B17,B17       ; |198| (P) <0,14> 

           SHR     .S1     A3,8,A3           ; |198| (P) <0,15>  ^ 
           SUB     .L1X    A6,B16,A5         ; |198| (P) <0,16>  ^ 

           ADD     .D2X    B9,A3,B17         ; |198| (P) <0,17>  ^ 
||         MPYUS   .M1     A16,A5,A3         ; |198| (P) <0,17>  ^ 
||         SHR     .S1X    B17,8,A3          ; |198| (P) <0,17> 

           SPMASK          L2
||         MV      .L2     B4,B5
||         ADD     .L1X    B7,A3,A7          ; |198| (P) <0,18> 

           EXTU    .S2     B17,24,16,B4      ; |198| (P) <0,19> 
||         EXTU    .S1     A7,24,24,A5       ; |198| (P) <0,19> 

           SHR     .S2X    A3,8,B18          ; |198| (P) <0,20>  ^ 
           ADD     .L2     B16,B18,B8        ; |198| <0,21>  ^ 

           EXTU    .S2     B8,24,24,B18      ; |198| <0,22> 
||         OR      .L2X    A5,B4,B4          ; |198| <0,22> 

           SHL     .S2     B4,8,B4           ; |198| <0,23> 
           OR      .L2     B18,B4,B4         ; |198| <0,24> 

           SPKERNEL 2,0
||         STW     .D2T2   B4,*B5++          ; |198| <0,25> 

;** --------------------------------------------------------------------------*
$C$L6:    ; PIPED LOOP EPILOG
           RETNOP  .S2     B3,5              ; |207| 
           ; BRANCH OCCURS {B3}              ; |207| 
	.sect	".text"
	.clink

;******************************************************************************
;* FUNCTION NAME: loc_multi_premul_srcover_argb32                             *
;*                                                                            *
;*   Regs Modified     : A0,A3,A4,A5,A6,A7,A8,A9,B4,B5,B6,B7,B8,B9,A16,A17,   *
;*                           A18,A19,A20,A21,A22,B16,B17                      *
;*   Regs Used         : A0,A3,A4,A5,A6,A7,A8,A9,B3,B4,B5,B6,B7,B8,B9,DP,SP,  *
;*                           A16,A17,A18,A19,A20,A21,A22,B16,B17              *
;*   Local Frame Size  : 0 Args + 0 Auto + 0 Save = 0 byte                    *
;******************************************************************************
_loc_multi_premul_srcover_argb32:
;** --------------------------------------------------------------------------*
;** 83	-----------------------    if ( !((_d-_s < 132)&(_s-_d < 132)) ) goto g4;
;**  	-----------------------    U$19 = _d;
;**  	-----------------------    K$25 = 256u;
;**  	-----------------------    U$26 = &_s[-2];
;**  	-----------------------    L$1 = _num+1u>>1;
;**  	-----------------------    #pragma MUST_ITERATE(32, 512, 4)
;**  	-----------------------    // LOOP BELOW UNROLLED BY FACTOR(2)
;**  	-----------------------    #pragma LOOP_FLAGS(4106u)

           MVK     .S1     132,A3            ; |83| 
||         SUB     .L2X    A4,B4,B5          ; |83| 
||         SUB     .L1X    B4,A4,A5          ; |83| 
||         ADD     .D1     1,A6,A8

           CMPLT   .L1     A5,A3,A9          ; |83| 
||         ADD     .D1     1,A6,A6
||         MVK     .S1     0x100,A7

           CMPLT   .L2X    B5,A3,B6          ; |83| 
||         MV      .L1X    B4,A3             ; |68| 

           MV      .L1X    B4,A5             ; |68| 
||         SHRU    .S2X    A8,1,B4
||         SHRU    .S1     A6,1,A8
||         SUB     .D1     A4,8,A6

           AND     .L1X    B6,A9,A0          ; |83| 
||         MV      .L2X    A7,B5

   [!A0]   BNOP    .S1     $C$L10,5          ; |83| 
|| [!A0]   SUB     .L1     A8,1,A8

           ; BRANCHCC OCCURS {$C$L10}        ; |83| 
;** --------------------------------------------------------------------------*
;**	-----------------------g3:
;** 84	-----------------------    VEC$u32x2$005 = _memd8((void *)U$19);
;** 110	-----------------------    C$15 = *(U$26 += 2);
;** 110	-----------------------    C$18 = C$15>>24;
;** 110	-----------------------    C$17 = K$25-(C$18&1u)-C$18;
;** 110	-----------------------    C$16 = _loll((unsigned long long)VEC$u32x2$005);
;** 110	-----------------------    *U$19 = _saddu4(C$15, (_extu(_mpyu(_extu(C$16, 8u, 24u), C$17), 16u, 24u)<<8|_extu(_mpyu(_extu(C$16, 16u, 24u)<<8, C$17), 8u, 24u))<<8|_extu(_mpyu(_extu(C$16, 24u, 24u), C$17), 16u, 24u));
;** 110	-----------------------    C$11 = U$26[1];
;** 110	-----------------------    C$14 = C$11>>24;
;** 110	-----------------------    C$13 = K$25-(C$14&1u)-C$14;
;** 110	-----------------------    C$12 = _hill((unsigned long long)VEC$u32x2$005);
;** 110	-----------------------    U$19[1] = _saddu4(C$11, (_extu(_mpyu(_extu(C$12, 8u, 24u), C$13), 16u, 24u)<<8|_extu(_mpyu(_extu(C$12, 16u, 24u)<<8, C$13), 8u, 24u))<<8|_extu(_mpyu(_extu(C$12, 24u, 24u), C$13), 16u, 24u));
;** 78	-----------------------    U$19 += 2;
;** 78	-----------------------    if ( L$1 = L$1-1 ) goto g3;

           DINT                              ; interrupts off
||         MV      .L2X    A6,B6
||         SUB     .L1X    B4,1,A0

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop found in file               : dsprite.c
;*      Loop source line                 : 78
;*      Loop opening brace source line   : 79
;*      Loop closing brace source line   : 160
;*      Loop Unroll Multiple             : 2x
;*      Known Minimum Trip Count         : 32                    
;*      Known Maximum Trip Count         : 512                    
;*      Known Max Trip Count Factor      : 4
;*      Loop Carried Dependency Bound(^) : 37
;*      Unpartitioned Resource Bound     : 12
;*      Partitioned Resource Bound(*)    : 12
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                    11       12*    
;*      .D units                     3        2     
;*      .M units                     2        4     
;*      .X cross paths               2        6     
;*      .T address paths             1        5     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          0       10     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             6        6     
;*      Bound(.L .S .D .LS .LSD)     5        8     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 37 Did not find schedule
;*         ii = 38 Schedule found with 1 iterations in parallel
;*      Done
;*
;*      Collapsed epilog stages       : 0
;*      Collapsed prolog stages       : 0
;*
;*      Minimum safe trip count       : 1 (after unrolling)
;*----------------------------------------------------------------------------*
$C$L7:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
$C$L8:    ; PIPED LOOP KERNEL
           LDW     .D2T2   *++B6(8),B7       ; |110| <0,0>  ^ 
           NOP             1
           LDNDW   .D1T1   *A3++(8),A5:A4    ; |84| <0,2> 
           NOP             2
           SHRU    .S2     B7,24,B8          ; |110| <0,5>  ^ 
           AND     .L2     1,B8,B4           ; |110| <0,6>  ^ 

           SUB     .L2     B5,B4,B4          ; |110| <0,7>  ^ 
||         EXTU    .S1     A4,8,24,A6        ; |110| <0,7> 

           SUB     .L2     B4,B8,B8          ; |110| <0,8>  ^ 
||         EXTU    .S1     A4,16,24,A7       ; |110| <0,8> 

           MPYU    .M2X    A6,B8,B4          ; |110| <0,9>  ^ 
||         SHL     .S1     A7,8,A6           ; |110| <0,9> 

           EXTU    .S1     A4,24,24,A4       ; |110| <0,10> 

           EXTU    .S1     A5,8,24,A6        ; |110| <0,11> 
||         EXTU    .S2     B4,16,24,B4       ; |110| <0,11>  ^ 
||         MPYU    .M2X    A6,B8,B8          ; |110| <0,11> 

           EXTU    .S1     A5,16,24,A4       ; |110| <0,12> 
||         MPYU    .M2X    A4,B8,B9          ; |110| <0,12> 
||         SHL     .S2     B4,8,B4           ; |110| <0,12>  ^ 

           SHL     .S1     A4,8,A4           ; |110| <0,13> 
||         EXTU    .S2     B8,8,24,B8        ; |110| <0,13> 

           EXTU    .S1     A5,24,24,A5       ; |110| <0,14> 
||         EXTU    .S2     B9,16,24,B8       ; |110| <0,14> 
||         OR      .L2     B8,B4,B4          ; |110| <0,14>  ^ 

           SHL     .S2     B4,8,B4           ; |110| <0,15>  ^ 
           OR      .L2     B8,B4,B4          ; |110| <0,16>  ^ 
           SADDU4  .S2     B7,B4,B4          ; |110| <0,17>  ^ 
           STW     .D1T2   B4,*-A3(8)        ; |110| <0,18>  ^ 
           LDW     .D2T2   *+B6(4),B7        ; |110| <0,19>  ^ 
           NOP             4
           SHRU    .S2     B7,24,B4          ; |110| <0,24>  ^ 
           AND     .L2     1,B4,B8           ; |110| <0,25>  ^ 
           SUB     .L2     B5,B8,B8          ; |110| <0,26>  ^ 
           SUB     .L2     B8,B4,B4          ; |110| <0,27>  ^ 
           MPYU    .M2X    A6,B4,B8          ; |110| <0,28> 
           MPYU    .M1X    A4,B4,A4          ; |110| <0,29>  ^ 

           MPYU    .M1X    A5,B4,A5          ; |110| <0,30> 
||         EXTU    .S2     B8,16,24,B4       ; |110| <0,30> 

           SHL     .S2     B4,8,B4           ; |110| <0,31> 
||         EXTU    .S1     A4,8,24,A4        ; |110| <0,31>  ^ 

   [ A0]   BDEC    .S1     $C$L8,A0          ; |78| <0,32> 

           EXTU    .S1     A5,16,24,A4       ; |110| <0,33> 
||         OR      .L2X    A4,B4,B4          ; |110| <0,33>  ^ 

           SHL     .S2     B4,8,B4           ; |110| <0,34>  ^ 
           OR      .L2X    A4,B4,B4          ; |110| <0,35>  ^ 
           SADDU4  .S2     B7,B4,B4          ; |110| <0,36>  ^ 
           STW     .D1T2   B4,*-A3(4)        ; |110| <0,37>  ^ 
;** --------------------------------------------------------------------------*
$C$L9:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
;** 78	-----------------------    goto g6;
;**	-----------------------g4:
;**  	-----------------------    U$19 = _d;
;**  	-----------------------    K$25 = 256u;
;**  	-----------------------    U$26 = _s;
;**  	-----------------------    L$2 = _num+1u>>1;
;**  	-----------------------    #pragma[60] (_s != _d;)
;**  	-----------------------    #pragma MUST_ITERATE(32, 512, 4)
;**  	-----------------------    // LOOP BELOW UNROLLED BY FACTOR(2)
;**  	-----------------------    #pragma LOOP_FLAGS(4162u)
;**	-----------------------g5:
;** 83	-----------------------    MVE$u32x2$003 = _memd8((void *)U$26);
;** 84	-----------------------    MVE$u32x2$004 = _memd8((void *)U$19);
;** 110	-----------------------    C$7 = _loll((unsigned long long)MVE$u32x2$003);
;** 110	-----------------------    C$10 = C$7>>24;
;** 110	-----------------------    C$9 = K$25-(C$10&1u)-C$10;
;** 110	-----------------------    C$8 = _loll((unsigned long long)MVE$u32x2$004);
;** 110	-----------------------    *U$19 = _saddu4(C$7, (_extu(_mpyu(_extu(C$8, 8u, 24u), C$9), 16u, 24u)<<8|_extu(_mpyu(_extu(C$8, 16u, 24u)<<8, C$9), 8u, 24u))<<8|_extu(_mpyu(_extu(C$8, 24u, 24u), C$9), 16u, 24u));
;** 110	-----------------------    C$3 = _hill((unsigned long long)MVE$u32x2$003);
;** 110	-----------------------    C$6 = C$3>>24;
;** 110	-----------------------    C$5 = K$25-(C$6&1u)-C$6;
;** 110	-----------------------    C$4 = _hill((unsigned long long)MVE$u32x2$004);
;** 110	-----------------------    U$19[1] = _saddu4(C$3, (_extu(_mpyu(_extu(C$4, 8u, 24u), C$5), 16u, 24u)<<8|_extu(_mpyu(_extu(C$4, 16u, 24u)<<8, C$5), 8u, 24u))<<8|_extu(_mpyu(_extu(C$4, 24u, 24u), C$5), 16u, 24u));
;** 78	-----------------------    U$19 += 2;
;** 78	-----------------------    U$26 += 2;
;** 78	-----------------------    if ( L$2 = L$2-1 ) goto g5;
;**	-----------------------g6:
;**  	-----------------------    return;
           RETNOP  .S2     B3,4              ; |161| 
           RINT                              ; interrupts on
           ; BRANCH OCCURS {B3}              ; |161| 
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop found in file               : dsprite.c
;*      Loop source line                 : 78
;*      Loop opening brace source line   : 79
;*      Loop closing brace source line   : 160
;*      Loop Unroll Multiple             : 2x
;*      Known Minimum Trip Count         : 32                    
;*      Known Maximum Trip Count         : 512                    
;*      Known Max Trip Count Factor      : 4
;*      Loop Carried Dependency Bound(^) : 0
;*      Unpartitioned Resource Bound     : 11
;*      Partitioned Resource Bound(*)    : 11
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                    11*      11*    
;*      .D units                     3        1     
;*      .M units                     4        2     
;*      .X cross paths               8        4     
;*      .T address paths             4        2     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        1     (.L or .S unit)
;*      Addition ops (.LSD)          7        3     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             6        6     
;*      Bound(.L .S .D .LS .LSD)     7        6     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 11 Schedule found with 3 iterations in parallel
;*      Done
;*
;*      Loop will be splooped
;*      Collapsed epilog stages       : 0
;*      Collapsed prolog stages       : 0
;*      Minimum required memory pad   : 0 bytes
;*
;*      Minimum safe trip count       : 1 (after unrolling)
;*----------------------------------------------------------------------------*
$C$L10:    ; PIPED LOOP PROLOG

           SPLOOPD 11      ;33               ; (P) 
||         MV      .L1     A4,A8
||         MVC     .S2X    A8,ILC

;** --------------------------------------------------------------------------*
$C$L11:    ; PIPED LOOP KERNEL
           LDNDW   .D1T1   *A8++(8),A21:A20  ; |83| (P) <0,0> 

           SPMASK          L2
||         MV      .L2X    A5,B6

           LDNDW   .D2T2   *B6++(8),B5:B4    ; |84| (P) <0,2> 
           NOP             2

           SHRU    .S1     A21,24,A6         ; |110| (P) <0,5> 
||         SHRU    .S2X    A20,24,B9         ; |110| (P) <0,5> 

           NOP             1
           MVD     .M1     A21,A9            ; |83| (P) <0,7> Split a long life

           MV      .L1X    B4,A3             ; |84| (P) <0,8> Define a twin register
||         AND     .L2     1,B9,B16          ; |110| (P) <0,8> 
||         EXTU    .S2     B5,24,24,B17      ; |110| (P) <0,8> 
||         AND     .D1     1,A6,A21          ; |110| (P) <0,8> 

           EXTU    .S2     B4,16,24,B8       ; |110| (P) <0,9> 
||         SUB     .D1     A7,A21,A19        ; |110| (P) <0,9> 

           MVD     .M1     A20,A16           ; |83| (P) <0,10> Split a long life
||         SUB     .L2X    A7,B16,B16        ; |110| (P) <0,10> 
||         EXTU    .S2     B4,8,24,B4        ; |110| (P) <0,10> 
||         SUB     .L1     A19,A6,A6         ; |110| (P) <0,10> 

           EXTU    .S2     B5,8,24,B7        ; |110| (P) <0,11> 

           SHL     .S1X    B8,8,A17          ; |110| (P) <0,12> 
||         EXTU    .S2     B5,16,24,B5       ; |110| (P) <0,12> 
||         MPYU    .M2X    B7,A6,B5          ; |110| (P) <0,12> 

           MPYU    .M1X    B17,A6,A18        ; |110| (P) <0,13> 
||         SHL     .S2     B5,8,B7           ; |110| (P) <0,13> 

           EXTU    .S1     A3,24,24,A3       ; |110| (P) <0,14> 
||         SUB     .L2     B16,B9,B5         ; |110| (P) <0,14> 
||         EXTU    .S2     B5,16,24,B8       ; |110| (P) <0,14> 

           EXTU    .S1     A18,16,24,A22     ; |110| (P) <0,15> 
||         MPYU    .M2     B4,B5,B4          ; |110| (P) <0,15> 
||         MPYU    .M1X    B7,A6,A17         ; |110| (P) <0,15> 
||         SHL     .S2     B8,8,B7           ; |110| (P) <0,15> 

           MPYU    .M1X    A17,B5,A3         ; |110| (P) <0,16> 

           MPYU    .M1X    A3,B5,A18         ; |110| (P) <0,17> 
||         EXTU    .S2     B4,16,24,B8       ; |110| (P) <0,17> 
||         EXTU    .S1     A17,8,24,A17      ; |110| (P) <0,17> 

           SHL     .S2     B8,8,B7           ; |110| (P) <0,18> 
||         OR      .L1X    A17,B7,A3         ; |110| (P) <0,18> 
||         EXTU    .S1     A3,8,24,A19       ; |110| (P) <0,18> 

           SHL     .S1     A3,8,A17          ; |110| (P) <0,19> 

           OR      .L1     A22,A17,A17       ; |110| (P) <0,20> 
||         EXTU    .S1     A18,16,24,A18     ; |110| (P) <0,20> 
||         OR      .L2X    A19,B7,B7         ; |110| (P) <0,20> 

           SPMASK          D1
||         ADD     .D1     4,A5,A4
||         SADDU4  .S1     A9,A17,A17        ; |110| (P) <0,21> 

           SHL     .S1X    B7,8,A19          ; |110| <0,22> 

           STW     .D1T1   A17,*A4++(8)      ; |110| <0,23> 
||         OR      .L1     A18,A19,A18       ; |110| <0,23> 

           SADDU4  .S1     A16,A18,A18       ; |110| <0,24> 

           SPKERNEL 0,0
||         STW     .D1T1   A18,*A5++(8)      ; |110| <0,25> 

;** --------------------------------------------------------------------------*
$C$L12:    ; PIPED LOOP EPILOG
           NOP             9
           RETNOP  .S2     B3,5              ; |161| 
           ; BRANCH OCCURS {B3}              ; |161| 
	.sect	".text"
	.clink

;******************************************************************************
;* FUNCTION NAME: loc_multi_alphatest_argb32                                  *
;*                                                                            *
;*   Regs Modified     : A0,A3,A4,A5,A6,A7,A8,B0,B4,B5,B6,B7,B8               *
;*   Regs Used         : A0,A3,A4,A5,A6,A7,A8,B0,B3,B4,B5,B6,B7,B8            *
;*   Local Frame Size  : 0 Args + 0 Auto + 0 Save = 0 byte                    *
;******************************************************************************
_loc_multi_alphatest_argb32:
;** --------------------------------------------------------------------------*
;** 58	-----------------------    if ( !((_d-_s < 132)&(_s-_d < 132)) ) goto g6;
;**  	-----------------------    U$16 = _s;
;**  	-----------------------    L$1 = _num;
;**  	-----------------------    U$15 = 0;
;**  	-----------------------    #pragma MUST_ITERATE(64, 1024, 8)
;**  	-----------------------    #pragma LOOP_FLAGS(4104u)

           MVK     .S2     132,B6            ; |58| 
||         SUB     .L2X    A4,B4,B5          ; |58| 
||         MV      .L1     A4,A3             ; |50| 
||         SUB     .S1X    B4,A4,A4          ; |58| 
||         ADD     .D1     1,A6,A5
||         ZERO    .D2     B8                ; |56| 

           CMPLT   .L2     B5,B6,B5          ; |58| 
||         SHRU    .S1     A5,1,A5

           CMPLT   .L1X    A4,B6,A7          ; |58| 
||         MV      .L2X    A6,B6             ; |50| 

           AND     .L1X    B5,A7,A0          ; |58| 
||         ZERO    .L2     B5                ; |56| 

   [!A0]   BNOP    .S1     $C$L16,5          ; |58| 
|| [!A0]   SUB     .L1     A5,2,A4
|| [ A0]   SUB     .L2     B6,1,B6

           ; BRANCHCC OCCURS {$C$L16}        ; |58| 
;** --------------------------------------------------------------------------*
;**	-----------------------g3:
;** 59	-----------------------    C$5 = *U$16++;
;** 59	-----------------------    if ( !(C$5>>24) ) goto g5;
;** 59	-----------------------    *(U$15+_d) = C$5;
;**	-----------------------g5:
;** 56	-----------------------    U$15 += 4;
;** 56	-----------------------    if ( L$1 = L$1-1 ) goto g3;
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop found in file               : dsprite.c
;*      Loop source line                 : 56
;*      Loop opening brace source line   : 57
;*      Loop closing brace source line   : 63
;*      Known Minimum Trip Count         : 64                    
;*      Known Maximum Trip Count         : 1024                    
;*      Known Max Trip Count Factor      : 8
;*      Loop Carried Dependency Bound(^) : 7
;*      Unpartitioned Resource Bound     : 1
;*      Partitioned Resource Bound(*)    : 2
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     1        0     
;*      .D units                     1        1     
;*      .M units                     0        0     
;*      .X cross paths               1        1     
;*      .T address paths             1        1     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          1        2     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             1        0     
;*      Bound(.L .S .D .LS .LSD)     1        1     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 7  Schedule found with 2 iterations in parallel
;*      Done
;*
;*      Loop will be splooped
;*      Collapsed epilog stages       : 0
;*      Collapsed prolog stages       : 0
;*      Minimum required memory pad   : 0 bytes
;*
;*      Minimum safe trip count       : 1
;*----------------------------------------------------------------------------*
$C$L13:    ; PIPED LOOP PROLOG

           SPLOOPD 7       ;14               ; (P) 
||         MVC     .S2     B6,ILC

;** --------------------------------------------------------------------------*
$C$L14:    ; PIPED LOOP KERNEL
           LDW     .D1T1   *A3++,A4          ; |59| (P) <0,0>  ^ 
           NOP             3

           SPMASK          L2
||         MV      .L2     B4,B6

           ADD     .L2     B6,B5,B7          ; |59| (P) <0,5> 
||         MV      .S2X    A4,B4             ; |59| (P) <0,5>  ^ Define a twin register
||         SHRU    .S1     A4,24,A0          ; |59| (P) <0,5>  ^ 

           ADD     .L2     4,B5,B5           ; |56| (P) <0,6> 
|| [ A0]   STW     .D2T2   B4,*B7            ; |59| (P) <0,6>  ^ 

           SPKERNEL 0,0
;** --------------------------------------------------------------------------*
$C$L15:    ; PIPED LOOP EPILOG
;** 56	-----------------------    goto g12;
;**	-----------------------g6:
;**  	-----------------------    U$16 = _s;
;**  	-----------------------    L$2 = _num+1u>>1;
;**  	-----------------------    U$15 = 0;
;** 56	-----------------------    i = 0u;
;**  	-----------------------    #pragma[60] (_s != _d;)
;**  	-----------------------    #pragma MUST_ITERATE(32, 512, 4)
;**  	-----------------------    // LOOP BELOW UNROLLED BY FACTOR(2)
;**  	-----------------------    #pragma LOOP_FLAGS(4162u)
           RETNOP  .S2     B3,5              ; |64| 
           ; BRANCH OCCURS {B3}              ; |64| 
;** --------------------------------------------------------------------------*
;**	-----------------------g7:
;** 58	-----------------------    MVE$u32x2$002 = _memd8((void *)U$16);
;** 59	-----------------------    U$36 = (unsigned long long)MVE$u32x2$002;
;** 59	-----------------------    C$4 = _loll(U$36);
;** 59	-----------------------    if ( !(C$4>>24) ) goto g9;
;** 59	-----------------------    *(U$15+_d) = C$4;
;**	-----------------------g9:
;** 59	-----------------------    C$3 = _hill(U$36);
;** 59	-----------------------    if ( !(C$3>>24) ) goto g11;
;** 59	-----------------------    _d[i+1] = C$3;
;**	-----------------------g11:
;** 56	-----------------------    U$15 += 8;
;** 56	-----------------------    U$16 += 2;
;** 56	-----------------------    i += 2u;
;** 56	-----------------------    if ( L$2 = L$2-1 ) goto g7;
;**	-----------------------g12:
;**  	-----------------------    return;
           SUB     .L1     A5,2,A4
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop found in file               : dsprite.c
;*      Loop source line                 : 56
;*      Loop opening brace source line   : 57
;*      Loop closing brace source line   : 63
;*      Loop Unroll Multiple             : 2x
;*      Known Minimum Trip Count         : 32                    
;*      Known Maximum Trip Count         : 512                    
;*      Known Max Trip Count Factor      : 4
;*      Loop Carried Dependency Bound(^) : 1
;*      Unpartitioned Resource Bound     : 2
;*      Partitioned Resource Bound(*)    : 2
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     1        1     
;*      .D units                     2*       1     
;*      .M units                     0        0     
;*      .X cross paths               1        2*    
;*      .T address paths             2*       2*    
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          2        3     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             1        1     
;*      Bound(.L .S .D .LS .LSD)     2*       2*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 2  Schedule found with 4 iterations in parallel
;*      Done
;*
;*      Loop will be splooped
;*      Collapsed epilog stages       : 0
;*      Collapsed prolog stages       : 0
;*      Minimum required memory pad   : 0 bytes
;*
;*      Minimum safe trip count       : 1 (after unrolling)
;*----------------------------------------------------------------------------*
$C$L16:    ; PIPED LOOP PROLOG

           SPLOOPD 2       ;8                ; (P) 
||         MV      .L1     A3,A8
||         MVC     .S2X    A4,ILC

;** --------------------------------------------------------------------------*
$C$L17:    ; PIPED LOOP KERNEL
           LDNDW   .D1T1   *A8++(8),A7:A6    ; |58| (P) <0,0> 
           NOP             3

           SPMASK          L2
||         MV      .L2     B4,B7

           SPMASK          L1
||         MV      .L1X    B8,A5
||         ROTL    .M1     A6,0,A3           ; |58| (P) <0,5> Split a long life
||         MV      .S2X    A7,B4             ; |58| (P) <0,5> Define a twin register
||         SHRU    .S1     A6,24,A0          ; |59| (P) <0,5> 

           ADD     .L1X    B7,A5,A4          ; |59| <0,6>  ^ 
||         ADD     .L2     1,B5,B6           ; |59| <0,6>  ^ 
||         SHRU    .S2X    A7,24,B0          ; |59| <0,6> 

           SPKERNEL 2,0
||         ADD     .L1     8,A5,A5           ; |56| <0,7>  ^ Define a twin register
||         ADD     .L2     2,B5,B5           ; |56| <0,7>  ^ Define a twin register
|| [ A0]   STW     .D1T1   A3,*A4            ; |59| <0,7> 
|| [ B0]   STW     .D2T2   B4,*+B7[B6]       ; |59| <0,7> 

;** --------------------------------------------------------------------------*
$C$L18:    ; PIPED LOOP EPILOG
           NOP             1
           RETNOP  .S2     B3,5              ; |64| 
           ; BRANCH OCCURS {B3}              ; |64| 
	.sect	".text"
	.clink

;******************************************************************************
;* FUNCTION NAME: loc_process                                                 *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,   *
;*                           A15,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9,B10,B11,B12,   *
;*                           B13,SP,A16,A17,A18,A19,A20,A21,A22,A23,A24,A25,  *
;*                           A26,A27,A28,A29,A30,A31,B16,B17,B18,B19,B20,B21, *
;*                           B22,B23,B24,B25,B26,B27,B28,B29,B30,B31          *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,A13,A14,   *
;*                           A15,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9,B10,B11,B12,   *
;*                           B13,DP,SP,A16,A17,A18,A19,A20,A21,A22,A23,A24,   *
;*                           A25,A26,A27,A28,A29,A30,A31,B16,B17,B18,B19,B20, *
;*                           B21,B22,B23,B24,B25,B26,B27,B28,B29,B30,B31      *
;*   Local Frame Size  : 0 Args + 24 Auto + 56 Save = 80 byte                 *
;******************************************************************************
_loc_process:
;** --------------------------------------------------------------------------*
;** 335	-----------------------    _union = *_union;
;** 338	-----------------------    (*syscalls.qdma_init)();
;**  	-----------------------    v$3 = syscalls.qdma_copy2d;
;**  	-----------------------    #pragma LOOP_FLAGS(5376u)
           STW     .D2T1   A11,*SP--(8)      ; |335| 
           STW     .D2T1   A10,*SP--(8)      ; |335| 
           STDW    .D2T2   B13:B12,*SP--     ; |335| 
           STDW    .D2T2   B11:B10,*SP--     ; |335| 
           STDW    .D2T1   A15:A14,*SP--     ; |335| 

           STDW    .D2T1   A13:A12,*SP--     ; |335| 
||         MVKL    .S1     _syscalls+192,A3

           STW     .D2T2   B3,*SP--(32)      ; |335| 
||         MVKH    .S1     _syscalls+192,A3

           LDW     .D1T1   *A3,A3            ; |338| 
           LDW     .D1T1   *A4,A13           ; |335| 
           NOP             3
           CALL    .S2X    A3                ; |338| 
           ADDKPC  .S2     $C$RL0,B3,4       ; |338| 
$C$RL0:    ; CALL OCCURS {A3} {0}            ; |338| 
;** --------------------------------------------------------------------------*
           MVKL    .S1     _syscalls+192,A3
           MVKH    .S1     _syscalls+192,A3
           MVK     .S2     12,B4
           ADD     .L2X    A3,B4,B4
           STW     .D2T2   B4,*+SP(24)

           LDW     .D1T1   *A13,A3           ; |342| 
||         LDW     .D2T2   *B4,B7
||         MVKL    .S1     $C$SW1,A4

;** --------------------------------------------------------------------------*
;**   BEGIN LOOP $C$L19
;** --------------------------------------------------------------------------*
$C$L19:    
           MVKH    .S1     $C$SW1,A4
           NOP             3
;** --------------------------------------------------------------------------*
;**   BEGIN LOOP $C$L20
;** --------------------------------------------------------------------------*
$C$L20:    
           CMPGTU  .L1     A3,4,A0           ; |342| 
;** --------------------------------------------------------------------------*
;**   BEGIN LOOP $C$L21
;** --------------------------------------------------------------------------*
$C$L21:    
;**	-----------------------g2:
;** 342	-----------------------    switch ( *(unsigned *)_union.op ) {case 0u: goto g3;, case 1u: goto g24;, case 2u: goto g6;, case 3u: goto g5;, case 4u: goto g4;, DEFAULT goto g9};

   [ A0]   BNOP    .S1     $C$L27,4          ; |342| 
|| [!A0]   LDW     .D1T1   *+A4[A3],A3       ; |342| 

   [!A0]   B       .S2X    A3                ; |342| 
           ; BRANCHCC OCCURS {$C$L27} {-6}   ; |342| 
;** --------------------------------------------------------------------------*
           NOP             5
           ; BRANCH OCCURS {A3}              ; |342| 
	.sect	".switch:_loc_process"
	.clink
$C$SW1:	.word	$C$L22	; 0
	.word	$C$L37	; 1
	.word	$C$L25	; 2
	.word	$C$L24	; 3
	.word	$C$L23	; 4
	.sect	".text"
;** --------------------------------------------------------------------------*
$C$L22:    
;**	-----------------------g3:
;** 349	-----------------------    return 0u;
           LDW     .D2T2   *++SP(32),B3      ; |538| 
           LDDW    .D2T1   *++SP,A13:A12     ; |538| 
           LDDW    .D2T1   *++SP,A15:A14     ; |538| 
           LDDW    .D2T2   *++SP,B11:B10     ; |538| 
           LDDW    .D2T2   *++SP,B13:B12     ; |538| 

           LDW     .D2T1   *++SP(8),A10      ; |538| 
||         RET     .S2     B3                ; |538| 

           LDW     .D2T1   *++SP(8),A11      ; |538| 
           ZERO    .L1     A4                ; |349| 
           NOP             3
           ; BRANCH OCCURS {B3}              ; |538| 
;** --------------------------------------------------------------------------*
$C$L23:    
;**	-----------------------g4:
;** 379	-----------------------    v$1 = _union.multi;
;** 378	-----------------------    multi_fxn = &loc_multi_srcover_argb32;
;** 379	-----------------------    goto g7;

           B       .S1     $C$L26            ; |379| 
||         MVKL    .S2     _loc_multi_srcover_argb32,B5

           MVKH    .S2     _loc_multi_srcover_argb32,B5
           MV      .L2X    A13,B4            ; |379| 

           MV      .L1X    B5,A3             ; |378| 
||         LDW     .D2T2   *+B4(12),B5       ; |383| 

           STW     .D2T1   A3,*+SP(4)        ; |378| 
           NOP             1
           ; BRANCH OCCURS {$C$L26}          ; |379| 
;** --------------------------------------------------------------------------*
$C$L24:    
;**	-----------------------g5:
;** 375	-----------------------    v$1 = _union.multi;
;** 374	-----------------------    multi_fxn = &loc_multi_premul_srcover_argb32;
;** 375	-----------------------    goto g7;

           B       .S1     $C$L26            ; |375| 
||         MVKL    .S2     _loc_multi_premul_srcover_argb32,B5

           MVKH    .S2     _loc_multi_premul_srcover_argb32,B5
           MV      .L2X    A13,B4            ; |375| 

           MV      .L1X    B5,A3             ; |374| 
||         LDW     .D2T2   *+B4(12),B5       ; |383| 

           STW     .D2T1   A3,*+SP(4)        ; |374| 
           NOP             1
           ; BRANCH OCCURS {$C$L26}          ; |375| 
;** --------------------------------------------------------------------------*
$C$L25:    
;**	-----------------------g6:
;** 371	-----------------------    v$1 = _union.multi;
;** 370	-----------------------    multi_fxn = &loc_multi_alphatest_argb32;
           MVKL    .S2     _loc_multi_alphatest_argb32,B5
           MVKH    .S2     _loc_multi_alphatest_argb32,B5
           MV      .L2X    A13,B4            ; |371| 

           MV      .L1X    B5,A3             ; |370| 
||         LDW     .D2T2   *+B4(12),B5       ; |383| 

           STW     .D2T1   A3,*+SP(4)        ; |370| 
           NOP             1
;** --------------------------------------------------------------------------*
$C$L26:    
;**	-----------------------g7:
;** 383	-----------------------    if ( !(num = (*v$1).num) ) goto g23;
           NOP             2

           MV      .L1X    B5,A0
||         STW     .D2T2   B5,*+SP(8)        ; |383| 

   [!A0]   B       .S1     $C$L36            ; |383| 
|| [ A0]   LDW     .D2T2   *+B4(8),B6        ; |387| 
|| [!A0]   ADDK    .S2     20,B4             ; |531| 

   [!A0]   BNOP    .S1     $C$L19,3          ; |531| 
|| [ A0]   LDW     .D2T2   *+B4(4),B5        ; |387| 

   [!A0]   MV      .L1X    B4,A13            ; |531| 
           ; BRANCHCC OCCURS {$C$L36}        ; |383| 
;** --------------------------------------------------------------------------*
;** 387	-----------------------    C$24 = (*v$1).h;
;** 387	-----------------------    C$23 = (*v$1).w;
;** 387	-----------------------    numPix = C$23*C$24;
;** 389	-----------------------    U$26 = C$24;
;** 389	-----------------------    U$25 = C$23;
;** 389	-----------------------    if ( U$25*U$26 < 1533u ) goto g10;
           MPY32   .M2     B6,B5,B8          ; |389| 
           MV      .L1X    B5,A3             ; |387| Define a twin register
           MVK     .S2     1533,B9           ; |389| 
           MPY32   .M1X    B6,A3,A3          ; |387| 
           CMPLTU  .L2     B8,B9,B0          ; |389| 

   [ B0]   BNOP    .S1     $C$L28,2          ; |389| 
|| [ B0]   LDW     .D2T2   *+B4(16),B8       ; |400| 
|| [ B0]   MV      .L1X    B4,A11

           STW     .D2T1   A3,*+SP(12)       ; |387| 
   [ B0]   ADD     .D1     A11,20,A15        ; |403| 
           ADD     .L1X    B8,A15,A11        ; |406| 
           ; BRANCHCC OCCURS {$C$L28}        ; |389| 
;** --------------------------------------------------------------------------*
$C$L27:    
;**	-----------------------g9:
;** 525	-----------------------    return _union.u32;
           LDW     .D2T2   *++SP(32),B3      ; |538| 

           MV      .L1     A13,A4            ; |525| 
||         LDDW    .D2T1   *++SP,A13:A12     ; |538| 

           LDDW    .D2T1   *++SP,A15:A14     ; |538| 
           LDDW    .D2T2   *++SP,B11:B10     ; |538| 
           LDDW    .D2T2   *++SP,B13:B12     ; |538| 

           LDW     .D2T1   *++SP(8),A10      ; |538| 
||         RET     .S2     B3                ; |538| 

           LDW     .D2T1   *++SP(8),A11      ; |538| 
           NOP             4
           ; BRANCH OCCURS {B3}              ; |538| 
;** --------------------------------------------------------------------------*
$C$L28:    
;**	-----------------------g10:
;** 391	-----------------------    w4 = U$25*4u;
;** 392	-----------------------    h = U$26;
;** 400	-----------------------    extSz = (*v$1).ext_sz;
;** 403	-----------------------    T$2 = &v$1[1];
;** 403	-----------------------    v$1 = T$2;
;** 403	-----------------------    _union.multi = v$1;
;** 403	-----------------------    ext = v$1;
;** 406	-----------------------    _union.u32 = _union.u32+extSz;
;** 408	-----------------------    v$4 = _union.sprite;
;** 408	-----------------------    spr = v$4;
;**  	-----------------------    K$62 = 0x10f05830u;
;** 393	-----------------------    workSrc = (unsigned *)0x10f04040u;
;** 411	-----------------------    if ( (C$22 = (*spr).src_phys_addr) < 0x10f10000u ) goto g12;

           LDW     .D1T1   *+A11(8),A3       ; |411| 
||         ZERO    .L1     A14
||         MVKL    .S2     0x10f04040,B4
||         MV      .S1X    B6,A10            ; |392| 

           MVKH    .S2     0x10f04040,B4
||         ADD     .L1X    B8,A15,A13        ; |406| 

           MVKH    .S1     0x10f10000,A14
           MVKL    .S2     0x10f05830,B11
           STW     .D2T2   B4,*+SP(16)       ; |393| 
           CMPLTU  .L1     A3,A14,A0         ; |411| 

   [ A0]   LDW     .D1T2   *+A11(8),B4       ; |414| 
|| [ A0]   B       .S1     $C$L29            ; |411| 

   [!A0]   CALL    .S2     B7                ; |418| 
   [!A0]   LDW     .D1T1   *+A11(12),A8      ; |418| 
           MVKH    .S2     0x10f05830,B11
           SHL     .S2     B5,2,B10          ; |391| 
   [ A0]   STW     .D2T2   B4,*+SP(20)       ; |414| 
           ; BRANCHCC OCCURS {$C$L29}        ; |411| 
;** --------------------------------------------------------------------------*
;** 418	-----------------------    U$56 = w4;
;** 418	-----------------------    (*v$3)(0u, (void *)workSrc, U$56, (void *)C$22, (*spr).src_pitch, (unsigned)U$56, h);
;** 427	-----------------------    v$3 = syscalls.qdma_copy2d;
;** 397	-----------------------    workSrcOverride = NULL;
;** 427	-----------------------    goto g13;

           MV      .L1X    B10,A6            ; |418| 
||         ZERO    .S1     A4                ; |418| 
||         MV      .L2X    A3,B6             ; |418| 
||         MV      .D2     B10,B8            ; |418| 
||         ADDKPC  .S2     $C$RL1,B3,0       ; |418| 

$C$RL1:    ; CALL OCCURS {B7} {0}            ; |418| 
;** --------------------------------------------------------------------------*

           BNOP    .S1     $C$L30,3          ; |427| 
||         LDW     .D2T2   *+SP(24),B4       ; |418| 
||         ZERO    .L2     B31               ; |397| 

           STW     .D2T2   B31,*+SP(20)      ; |427| 
           LDW     .D2T2   *B4,B7            ; |427| 
           ; BRANCH OCCURS {$C$L30}          ; |427| 
;** --------------------------------------------------------------------------*
$C$L29:    
;**	-----------------------g12:
;** 414	-----------------------    workSrcOverride = (unsigned *)(*spr).src_phys_addr;
;**  	-----------------------    U$56 = w4;
;** --------------------------------------------------------------------------*
$C$L30:    
;**	-----------------------g13:
;** 394	-----------------------    workDst = (unsigned *)K$62;
;** 431	-----------------------    (*v$3)(1u, (void *)workDst, U$56, (void *)(*spr).dst_phys_addr, (*spr).dst_pitch, w4, h);
;** 440	-----------------------    if ( !num ) goto g22;
           LDW     .D1T1   *+A11(4),A8       ; |431| 
           LDW     .D1T2   *A11,B6           ; |431| 
           MV      .L1X    B11,A12           ; |394| 
           MV      .L2     B11,B4            ; |394| 
           CALL    .S2     B7                ; |431| 
           MVK     .L1     0x1,A4            ; |431| 
           MV      .L1X    B10,A6            ; |431| 
           MV      .L2     B10,B8            ; |431| 
           ADDKPC  .S2     $C$RL2,B3,1       ; |431| 
$C$RL2:    ; CALL OCCURS {B7} {0}            ; |431| 
;** --------------------------------------------------------------------------*
           LDW     .D2T1   *+SP(8),A0        ; |431| 
           MVKL    .S2     _syscalls+196,B4
           MVKH    .S2     _syscalls+196,B4
           NOP             2

   [!A0]   BNOP    .S1     $C$L35,5          ; |440| 
|| [ A0]   LDW     .D2T2   *B4,B4            ; |443| 

           ; BRANCHCC OCCURS {$C$L35}        ; |440| 
;** --------------------------------------------------------------------------*
;**  	-----------------------    U$101 = &v$4[1];
;** 395	-----------------------    workSrcNext = (unsigned *)0x10f07020u;
;** 396	-----------------------    workDstNext = (unsigned *)0x10f08810u;
;** 398	-----------------------    workSrcOverrideNext = NULL;
;** 411	-----------------------    K$51 = 0x10f10000u;
;**  	-----------------------    #pragma MUST_ITERATE(1, 4294967295, 1)
;**  	-----------------------    #pragma LOOP_FLAGS(1024u)

           ZERO    .L1     A4                ; |443| 
||         ZERO    .L2     B11               ; |398| 
||         ADD     .D1     A13,16,A14

           MVKL    .S2     0x10f08810,B13
           MVKL    .S2     0x10f07020,B12
           MVKH    .S2     0x10f07020,B12
           CALL    .S2     B4                ; |443| 
           MVKH    .S2     0x10f08810,B13
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*      Disqualified loop: Loop contains a call
;*      Disqualified loop: Loop contains non-pipelinable instructions
;*      Disqualified loop: Loop contains a call
;*      Disqualified loop: Loop contains non-pipelinable instructions
;*      Disqualified loop: Loop contains control code
;*----------------------------------------------------------------------------*
$C$L31:    
;**	-----------------------g15:
;** 443	-----------------------    (*syscalls.qdma_wait)(0u);
;** 444	-----------------------    (*syscalls.qdma_wait)(1u);
;** 446	-----------------------    if ( !(--num) ) goto g20;
           ADDKPC  .S2     $C$RL3,B3,3       ; |443| 
$C$RL3:    ; CALL OCCURS {B4} {0}            ; |443| 
;** --------------------------------------------------------------------------*
           MVKL    .S1     _syscalls+196,A3
           MVKH    .S1     _syscalls+196,A3
           LDW     .D1T1   *A3,A3            ; |444| 
           MVK     .L1     0x1,A4            ; |444| 
           NOP             3
           CALL    .S2X    A3                ; |444| 
           ADDKPC  .S2     $C$RL4,B3,4       ; |444| 
$C$RL4:    ; CALL OCCURS {A3} {0}            ; |444| 
;** --------------------------------------------------------------------------*
           LDW     .D2T2   *+SP(8),B4        ; |444| 
           NOP             4

           SUB     .L1X    B4,1,A0           ; |446| 
||         SUB     .L2     B4,1,B4           ; |446| 

   [!A0]   B       .S1     $C$L34            ; |446| 
|| [ A0]   LDW     .D1T1   *+A11(24),A3      ; |448| 
||         STW     .D2T2   B4,*+SP(8)        ; |446| 
|| [ A0]   MVKL    .S2     _syscalls+204,B4
|| [ A0]   ZERO    .L1     A4

           MV      .L1     A0,A2             ; |446| branch predicate copy
|| [ A0]   MVKH    .S1     0x10f10000,A4

   [ A0]   MVKH    .S2     _syscalls+204,B4
   [ A0]   LDW     .D2T2   *B4,B5            ; |448| 
   [!A2]   LDW     .D2T2   *+SP(4),B5        ; |482| 

           CMPLTU  .L1     A3,A4,A0          ; |448| 
|| [!A2]   LDW     .D2T1   *+SP(20),A0

           ; BRANCHCC OCCURS {$C$L34}        ; |446| 
;** --------------------------------------------------------------------------*
;** 448	-----------------------    v$3 = syscalls.qdma_copy2d;
;** 448	-----------------------    U$83 = *((unsigned *)spr+24);
;** 448	-----------------------    if ( U$83 < K$51 ) goto g18;
   [ A0]   BNOP    .S1     $C$L32,1          ; |448| 
   [!A0]   CALL    .S2     B5                ; |456| 
   [!A0]   LDW     .D1T1   *+A11(28),A8      ; |456| 
   [ A0]   MV      .L2X    A3,B11            ; |451| 
           NOP             1
           ; BRANCHCC OCCURS {$C$L32}        ; |448| 
;** --------------------------------------------------------------------------*
;** 456	-----------------------    (*v$3)(0u, (void *)workSrcNext, U$56, (void *)U$83, *((int *)spr+28), w4, h);
;** 465	-----------------------    v$3 = syscalls.qdma_copy2d;
;** 465	-----------------------    workSrcOverrideNext = NULL;
;** 465	-----------------------    goto g19;
           MV      .L2X    A3,B6             ; |456| 

           MV      .L2     B10,B8            ; |456| 
||         MV      .L1X    B10,A6            ; |456| 
||         MV      .D2     B12,B4            ; |456| 
||         ZERO    .S1     A4                ; |456| 
||         ADDKPC  .S2     $C$RL5,B3,0       ; |456| 

$C$RL5:    ; CALL OCCURS {B5} {0}            ; |456| 
;** --------------------------------------------------------------------------*

           MVKL    .S2     _syscalls+204,B4
||         B       .S1     $C$L33            ; |465| 

           MVKH    .S2     _syscalls+204,B4
           LDW     .D2T2   *B4,B5            ; |465| 
           ZERO    .L2     B11               ; |465| 
           NOP             2
           ; BRANCH OCCURS {$C$L33}          ; |465| 
;** --------------------------------------------------------------------------*
$C$L32:    
;**	-----------------------g18:
;** 451	-----------------------    workSrcOverrideNext = (unsigned *)U$83;
;** --------------------------------------------------------------------------*
$C$L33:    
;**	-----------------------g19:
;** 469	-----------------------    (*v$3)(1u, (void *)workDstNext, U$56, (void *)*((unsigned *)spr+16), *((int *)spr+20), w4, h);
           LDW     .D1T1   *+A11(20),A8      ; |469| 
           CALL    .S2     B5                ; |469| 
           LDW     .D1T2   *+A11(16),B6      ; |469| 
           ADDKPC  .S2     $C$RL6,B3,2       ; |469| 

           MV      .L2     B13,B4            ; |469| 
||         MVK     .L1     0x1,A4            ; |469| 
||         MV      .S1X    B10,A6            ; |469| 
||         MV      .S2     B10,B8            ; |469| 

$C$RL6:    ; CALL OCCURS {B5} {0}            ; |469| 
           LDW     .D2T2   *+SP(4),B5        ; |482| 
           LDW     .D2T1   *+SP(20),A0
;** --------------------------------------------------------------------------*
$C$L34:    
;**	-----------------------g20:
;** 482	-----------------------    (workSrcOverride != NULL) ? (S$1 = workSrcOverride) : (S$1 = workSrc);
;** 482	-----------------------    (*multi_fxn)(S$1, workDst, numPix, ext);
;** 486	-----------------------    (*syscalls.qdma_wait)(2u);
;** 489	-----------------------    (*syscalls.qdma_copy2d)(2u, (void *)(*spr).dst_phys_addr, (*spr).dst_pitch, (const void *)workDst, U$56, w4, h);
;** 502	-----------------------    t = (void *)workSrc;
;** 503	-----------------------    workSrc = workSrcNext;
;** 504	-----------------------    workSrcNext = (unsigned *)t;
;** 506	-----------------------    t = (void *)workDst;
;** 507	-----------------------    workDst = workDstNext;
;** 508	-----------------------    workDstNext = (unsigned *)t;
;** 511	-----------------------    workSrcOverride = workSrcOverrideNext;
;** 514	-----------------------    T$3 = U$101;
;** 514	-----------------------    U$101 += 16;
;** 514	-----------------------    v$5 = v$4 += 16;
;** 514	-----------------------    spr = T$3;
;** 440	-----------------------    if ( num ) goto g15;
           LDW     .D2T1   *+SP(12),A6       ; |482| 
           MV      .L2X    A12,B4            ; |482| 
           MV      .L2X    A15,B6            ; |482| 
           CALL    .S2     B5                ; |482| 
   [!A0]   LDW     .D2T1   *+SP(16),A4       ; |482| 
           ADDKPC  .S2     $C$RL7,B3,2       ; |482| 
   [ A0]   MV      .L1     A0,A4
$C$RL7:    ; CALL OCCURS {VR245} {0}         ; |482| 
;** --------------------------------------------------------------------------*
           MVKL    .S2     _syscalls+196,B4
           MVKH    .S2     _syscalls+196,B4
           LDW     .D2T2   *B4,B4            ; |486| 
           MVK     .L1     0x2,A4            ; |486| 
           NOP             3
           CALL    .S2     B4                ; |486| 
           ADDKPC  .S2     $C$RL8,B3,4       ; |486| 
$C$RL8:    ; CALL OCCURS {B4} {0}            ; |486| 
           MVKL    .S1     _syscalls+204,A4
           MVKH    .S1     _syscalls+204,A4
           LDW     .D1T1   *A4,A5            ; |489| 
           LDW     .D1T1   *+A11(4),A6       ; |489| 
           LDW     .D1T2   *A11,B4           ; |489| 
           MVK     .L1     0x2,A4            ; |489| 
           MV      .L2X    A12,B6            ; |489| 
           CALL    .S2X    A5                ; |489| 
           MV      .L1X    B10,A8            ; |489| 
           MV      .L2     B10,B8            ; |489| 
           ADDKPC  .S2     $C$RL9,B3,2       ; |489| 
$C$RL9:    ; CALL OCCURS {A5} {0}            ; |489| 
;** --------------------------------------------------------------------------*
           LDW     .D2T1   *+SP(8),A0        ; |508| 
           MVKL    .S2     _syscalls+196,B4
           LDW     .D2T1   *+SP(16),A3       ; |489| 
           MVKH    .S2     _syscalls+196,B4
           MV      .L1     A12,A5            ; |506| 
   [ A0]   LDW     .D2T2   *B4,B4            ; |443| 
   [ A0]   BNOP    .S1     $C$L31,2          ; |440| 
   [ A0]   ZERO    .L1     A4                ; |443| 

   [ A0]   CALL    .S2     B4                ; |443| 
||         MV      .L1X    B13,A12           ; |507| 
||         MV      .L2X    A5,B13            ; |508| 
||         STW     .D2T2   B12,*+SP(16)      ; |503| 
||         MV      .D1     A14,A11           ; |514| 
||         ADDK    .S1     16,A14            ; |514| 

           ADDK    .S1     16,A13            ; |514| 
||         MV      .L2X    A3,B12            ; |504| 
||         STW     .D2T2   B11,*+SP(20)      ; |511| 

           ; BRANCHCC OCCURS {$C$L31}        ; |440| 
;** --------------------------------------------------------------------------*
;**  	-----------------------    _union.sprite = v$5;
;** --------------------------------------------------------------------------*
$C$L35:    
;**	-----------------------g22:
;** 519	-----------------------    (*syscalls.qdma_wait)(2u);
;** 521	-----------------------    v$3 = syscalls.qdma_copy2d;
;** 521	-----------------------    goto g2;
           MVKL    .S1     _syscalls+192,A3
           MVKH    .S1     _syscalls+192,A3
           ADD     .L1     4,A3,A3
           LDW     .D1T1   *A3,A3            ; |519| 
           MVK     .L1     0x2,A4            ; |519| 
           NOP             3
           CALL    .S2X    A3                ; |519| 
           ADDKPC  .S2     $C$RL10,B3,4      ; |519| 
$C$RL10:   ; CALL OCCURS {A3} {0}            ; |519| 
;** --------------------------------------------------------------------------*

           BNOP    .S2     $C$L21,3          ; |521| 
||         LDW     .D2T2   *+SP(24),B4       ; |519| 
||         LDW     .D1T1   *A13,A3           ; |342| 
||         MVKL    .S1     $C$SW1,A4

           MVKH    .S1     $C$SW1,A4

           LDW     .D2T2   *B4,B7            ; |521| 
||         CMPGTU  .L1     A3,4,A0           ; |342| 

           ; BRANCH OCCURS {$C$L21}          ; |521| 
;** --------------------------------------------------------------------------*
$C$L36:    
;**	-----------------------g23:
;** 531	-----------------------    _union.multi = v$1 += 20;
;** 531	-----------------------    goto g2;

           LDW     .D1T1   *A13,A3           ; |342| 
||         MVKL    .S1     $C$SW1,A4

           ; BRANCH OCCURS {$C$L19}          ; |531| 
;** --------------------------------------------------------------------------*
$C$L37:    
;**	-----------------------g24:
;** 353	-----------------------    v$2 = _union.copy;
;** 353	-----------------------    (*v$3)(0u, (void *)(*v$2).sprite.dst_phys_addr, (*v$2).sprite.dst_pitch, (void *)(*v$2).sprite.src_phys_addr, (*v$2).sprite.src_pitch, (*v$2).num_bytes_x, (*v$2).num_y);
;** 362	-----------------------    (*syscalls.qdma_wait)(0u);
;** 365	-----------------------    _union.copy = v$2 += 28;
;** 367	-----------------------    v$3 = syscalls.qdma_copy2d;
;** 367	-----------------------    goto g2;
           LDW     .D1T2   *+A13(4),B8       ; |353| 
           LDW     .D1T1   *+A13(24),A8      ; |353| 
           LDW     .D1T2   *+A13(20),B6      ; |353| 
           LDW     .D1T1   *+A13(16),A6      ; |353| 

           CALL    .S2     B7                ; |353| 
||         LDW     .D1T1   *+A13(8),A10      ; |353| 

           LDW     .D1T2   *+A13(12),B4      ; |353| 
           ADDKPC  .S2     $C$RL11,B3,2      ; |353| 
           ZERO    .L1     A4                ; |353| 
$C$RL11:   ; CALL OCCURS {B7} {0}            ; |353| 
;** --------------------------------------------------------------------------*
           MVKL    .S1     _syscalls+192,A3
           MVKH    .S1     _syscalls+192,A3
           ZERO    .L1     A4                ; |362| 
           ADD     .L2X    4,A3,B4
           LDW     .D2T2   *B4,B4            ; |362| 
           NOP             4
           CALL    .S2     B4                ; |362| 
           ADDKPC  .S2     $C$RL12,B3,4      ; |362| 
$C$RL12:   ; CALL OCCURS {B4} {0}            ; |362| 
;** --------------------------------------------------------------------------*

           LDW     .D2T2   *+SP(24),B4       ; |362| 
||         B       .S2     $C$L20            ; |367| 
||         ADDK    .S1     28,A13            ; |365| 

           LDW     .D1T1   *A13,A3           ; |342| 
           MVKL    .S1     $C$SW1,A4
           MVKH    .S1     $C$SW1,A4
           NOP             1
           LDW     .D2T2   *B4,B7            ; |367| 
           ; BRANCH OCCURS {$C$L20}          ; |367| 
	.sect	".text"
	.clink

;******************************************************************************
;* FUNCTION NAME: loc_nops                                                    *
;*                                                                            *
;*   Regs Modified     : A0,A3,B4                                             *
;*   Regs Used         : A0,A3,B3,B4                                          *
;*   Local Frame Size  : 0 Args + 0 Auto + 0 Save = 0 byte                    *
;******************************************************************************
_loc_nops:
;** --------------------------------------------------------------------------*
;** 216	-----------------------    xxx = 42u;
;** 219	-----------------------    L$1 = 8000000;
;**  	-----------------------    #pragma MUST_ITERATE(8000000, 8000000, 8000000)
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)
;**	-----------------------g2:
;** 221	-----------------------    asm("\n\tnop");
;
	nop
;** 222	-----------------------    asm("\n\tnop");
;
	nop
;** 223	-----------------------    asm("\n\tnop");
;
	nop
;** 224	-----------------------    asm("\n\tnop");
;
	nop
;** 225	-----------------------    asm("\n\tnop");
;
	nop
;** 226	-----------------------    asm("\n\tnop");
;
	nop
;** 227	-----------------------    asm("\n\tnop");
;
	nop
;** 228	-----------------------    asm("\n\tnop");
;
	nop
;** 229	-----------------------    asm("\n\tnop");
;
	nop
;** 230	-----------------------    asm("\n\tnop");
;
	nop
;** 232	-----------------------    asm("\n\tnop");
;
	nop
;** 233	-----------------------    asm("\n\tnop");
;
	nop
;** 234	-----------------------    asm("\n\tnop");
;
	nop
;** 235	-----------------------    asm("\n\tnop");
;
	nop
;** 236	-----------------------    asm("\n\tnop");
;
	nop
;** 237	-----------------------    asm("\n\tnop");
;
	nop
;** 238	-----------------------    asm("\n\tnop");
;
	nop
;** 239	-----------------------    asm("\n\tnop");
;
	nop
;** 240	-----------------------    asm("\n\tnop");
;
	nop
;** 241	-----------------------    asm("\n\tnop");
;
	nop
;** 243	-----------------------    asm("\n\tnop");
;
	nop
;** 244	-----------------------    asm("\n\tnop");
;
	nop
;** 245	-----------------------    asm("\n\tnop");
;
	nop
;** 246	-----------------------    asm("\n\tnop");
;
	nop
;** 247	-----------------------    asm("\n\tnop");
;
	nop
;** 248	-----------------------    asm("\n\tnop");
;
	nop
;** 249	-----------------------    asm("\n\tnop");
;
	nop
;** 250	-----------------------    asm("\n\tnop");
;
	nop
;** 251	-----------------------    asm("\n\tnop");
;
	nop
;** 252	-----------------------    asm("\n\tnop");
;
	nop
;** 254	-----------------------    asm("\n\tnop");
;
	nop
;** 255	-----------------------    asm("\n\tnop");
;
	nop
;** 256	-----------------------    asm("\n\tnop");
;
	nop
;** 257	-----------------------    asm("\n\tnop");
;
	nop
;** 258	-----------------------    asm("\n\tnop");
;
	nop
;** 259	-----------------------    asm("\n\tnop");
;
	nop
;** 260	-----------------------    asm("\n\tnop");
;
	nop
;** 261	-----------------------    asm("\n\tnop");
;
	nop
;** 262	-----------------------    asm("\n\tnop");
;
	nop
;** 263	-----------------------    asm("\n\tnop");
;
	nop
;** 265	-----------------------    asm("\n\tnop");
;
	nop
;** 266	-----------------------    asm("\n\tnop");
;
	nop
;** 267	-----------------------    asm("\n\tnop");
;
	nop
;** 268	-----------------------    asm("\n\tnop");
;
	nop
;** 269	-----------------------    asm("\n\tnop");
;
	nop
;** 270	-----------------------    asm("\n\tnop");
;
	nop
;** 271	-----------------------    asm("\n\tnop");
;
	nop
;** 272	-----------------------    asm("\n\tnop");
;
	nop
;** 273	-----------------------    asm("\n\tnop");
;
	nop
;** 274	-----------------------    asm("\n\tnop");
;
	nop
;** 276	-----------------------    asm("\n\tnop");
;
	nop
;** 277	-----------------------    asm("\n\tnop");
;
	nop
;** 278	-----------------------    asm("\n\tnop");
;
	nop
;** 279	-----------------------    asm("\n\tnop");
;
	nop
;** 280	-----------------------    asm("\n\tnop");
;
	nop
;** 281	-----------------------    asm("\n\tnop");
;
	nop
;** 282	-----------------------    asm("\n\tnop");
;
	nop
;** 283	-----------------------    asm("\n\tnop");
;
	nop
;** 284	-----------------------    asm("\n\tnop");
;
	nop
;** 285	-----------------------    asm("\n\tnop");
;
	nop
;** 287	-----------------------    asm("\n\tnop");
;
	nop
;** 288	-----------------------    asm("\n\tnop");
;
	nop
;** 289	-----------------------    asm("\n\tnop");
;
	nop
;** 290	-----------------------    asm("\n\tnop");
;
	nop
;** 291	-----------------------    asm("\n\tnop");
;
	nop
;** 292	-----------------------    asm("\n\tnop");
;
	nop
;** 293	-----------------------    asm("\n\tnop");
;
	nop
;** 294	-----------------------    asm("\n\tnop");
;
	nop
;** 295	-----------------------    asm("\n\tnop");
;
	nop
;** 296	-----------------------    asm("\n\tnop");
;
	nop
;** 298	-----------------------    asm("\n\tnop");
;
	nop
;** 299	-----------------------    asm("\n\tnop");
;
	nop
;** 300	-----------------------    asm("\n\tnop");
;
	nop
;** 301	-----------------------    asm("\n\tnop");
;
	nop
;** 302	-----------------------    asm("\n\tnop");
;
	nop
;** 303	-----------------------    asm("\n\tnop");
;
	nop
;** 304	-----------------------    asm("\n\tnop");
;
	nop
;** 305	-----------------------    asm("\n\tnop");
;
	nop
;** 306	-----------------------    asm("\n\tnop");
;
	nop
;** 307	-----------------------    asm("\n\tnop");
;
	nop
;** 309	-----------------------    asm("\n\tnop");
;
	nop
;** 310	-----------------------    asm("\n\tnop");
;
	nop
;** 311	-----------------------    asm("\n\tnop");
;
	nop
;** 312	-----------------------    asm("\n\tnop");
;
	nop
;** 313	-----------------------    asm("\n\tnop");
;
	nop
;** 314	-----------------------    asm("\n\tnop");
;
	nop
;** 315	-----------------------    asm("\n\tnop");
;
	nop
;** 316	-----------------------    asm("\n\tnop");
;
	nop
;** 317	-----------------------    asm("\n\tnop");
;
	nop
;** 318	-----------------------    asm("\n\tnop");
;
	nop
;** 320	-----------------------    asm("\n\tnop");
;
	nop
;** 321	-----------------------    asm("\n\tnop");
;
	nop
;** 322	-----------------------    asm("\n\tnop");
;
	nop
;** 323	-----------------------    asm("\n\tnop");
;
	nop
;** 324	-----------------------    asm("\n\tnop");
;
	nop
;** 325	-----------------------    asm("\n\tnop");
;
	nop
;** 326	-----------------------    asm("\n\tnop");
;
	nop
;** 327	-----------------------    asm("\n\tnop");
;
	nop
;** 328	-----------------------    asm("\n\tnop");
;
	nop
;** 329	-----------------------    asm("\n\tnop");
;
	nop
;** 219	-----------------------    if ( L$1 = L$1-1 ) goto g2;
;**  	-----------------------    return;
           MVKL    .S1     0x7a1200,A0
           MVKL    .S1     _xxx,A3
           MVKH    .S1     0x7a1200,A0

           SUB     .L1     A0,6,A0
||         MVKH    .S1     _xxx,A3

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop found in file               : dsprite.c
;*      Loop source line                 : 219
;*      Loop opening brace source line   : 220
;*      Loop closing brace source line   : 330
;*      Known Minimum Trip Count         : 8000000                    
;*      Known Max Trip Count Factor      : 8000000
;*      Loop Carried Dependency Bound(^) : 0
;*      Unpartitioned Resource Bound     : 1
;*      Partitioned Resource Bound(*)    : 1
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     1*       0     
;*      .D units                     0        0     
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             0        0     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          0        0     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             1*       0     
;*      Bound(.L .S .D .LS .LSD)     1*       0     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 1  Schedule found with 6 iterations in parallel
;*      Done
;*
;*      Collapsed epilog stages       : 0
;*      Collapsed prolog stages       : 0
;*      Minimum required memory pad   : 0 bytes
;*
;*      Minimum safe trip count       : 6
;*----------------------------------------------------------------------------*
$C$L38:    ; PIPED LOOP PROLOG
   [ A0]   BDEC    .S1     $C$L39,A0         ; |219| (P) <0,0> 
   [ A0]   BDEC    .S1     $C$L39,A0         ; |219| (P) <1,0> 
   [ A0]   BDEC    .S1     $C$L39,A0         ; |219| (P) <2,0> 

           MVK     .S2     42,B4             ; |216| 
|| [ A0]   BDEC    .S1     $C$L39,A0         ; |219| (P) <3,0> 

           STW     .D1T2   B4,*A3            ; |216| 
|| [ A0]   BDEC    .S1     $C$L39,A0         ; |219| (P) <4,0> 

;** --------------------------------------------------------------------------*
$C$L39:    ; PIPED LOOP KERNEL
   [ A0]   BDEC    .S1     $C$L39,A0         ; |219| <5,0> 
;** --------------------------------------------------------------------------*
$C$L40:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
           RETNOP  .S2     B3,5              ; |331| 
           ; BRANCH OCCURS {B3}              ; |331| 
	.sect	".text"
	.clink

;******************************************************************************
;* FUNCTION NAME: loc_exec                                                    *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,B0,B1,B2,B3,B4,B5,B6,  *
;*                           B7,B8,B9,B10,B11,SP,A16,A17,A18,A19,A20,A21,A22, *
;*                           A23,A24,A25,A26,A27,A28,A29,A30,A31,B16,B17,B18, *
;*                           B19,B20,B21,B22,B23,B24,B25,B26,B27,B28,B29,B30, *
;*                           B31                                              *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,B0,B1,B2,B3,B4,B5,B6,  *
;*                           B7,B8,B9,B10,B11,DP,SP,A16,A17,A18,A19,A20,A21,  *
;*                           A22,A23,A24,A25,A26,A27,A28,A29,A30,A31,B16,B17, *
;*                           B18,B19,B20,B21,B22,B23,B24,B25,B26,B27,B28,B29, *
;*                           B30,B31                                          *
;*   Local Frame Size  : 0 Args + 4 Auto + 8 Save = 12 byte                   *
;******************************************************************************
_loc_exec:
;** --------------------------------------------------------------------------*
;** 548	-----------------------    switch ( _cmd ) {case 1: goto g2;, case 2: goto g3;, DEFAULT goto g4};

           CMPEQ   .L2X    A4,1,B0           ; |548| 
||         CMPEQ   .L1     A4,2,A0           ; |548| 
||         STW     .D2T2   B11,*SP--(16)     ; |545| 
||         MV      .S2     B3,B11            ; |545| 

   [ B0]   B       .S1     $C$L41            ; |548| 
|| [ B0]   ZERO    .L1     A0                ; |568| nullify predicate
||         STW     .D2T2   B10,*+SP(12)      ; |545| 

   [ A0]   B       .S1     $C$L42            ; |548| 
   [ B0]   CALL    .S1     _loc_process      ; |560| 
           MV      .L2     B6,B10            ; |545| 
   [!B0]   ZERO    .L2     B5                ; |568| 
           ADD     .L1X    4,SP,A4           ; |560| 
           ; BRANCHCC OCCURS {$C$L41}        ; |548| 
;** --------------------------------------------------------------------------*
   [!A0]   B       .S1     $C$L43            ; |548| 
           ; BRANCHCC OCCURS {$C$L42}        ; |548| 
;** --------------------------------------------------------------------------*

           RET     .S2     B3                ; |574| 
||         LDW     .D2T2   *+SP(12),B10      ; |574| 

           LDW     .D2T2   *++SP(16),B11     ; |574| 
           MVK     .L1     0x1,A4            ; |573| 
           NOP             2
           ; BRANCH OCCURS {$C$L43}          ; |548| 
;** --------------------------------------------------------------------------*
$C$L41:    
;**	-----------------------g2:
;** 558	-----------------------    ptr.u32 = _arg1;
;** 560	-----------------------    ret = loc_process(&ptr);
;** 560	-----------------------    *_ret1 = ret;
;** 573	-----------------------    return ret;
           STW     .D2T2   B4,*+SP(4)        ; |558| 
           ADDKPC  .S2     $C$RL13,B3,0      ; |560| 
$C$RL13:   ; CALL OCCURS {_loc_process} {0}  ; |560| 
;** --------------------------------------------------------------------------*

           MV      .L2     B11,B3            ; |574| 
||         STW     .D2T1   A4,*B10           ; |560| 

           RET     .S2     B3                ; |574| 
||         LDW     .D2T2   *+SP(12),B10      ; |574| 

           LDW     .D2T2   *++SP(16),B11     ; |574| 
           NOP             4
           ; BRANCH OCCURS {B3}              ; |574| 
;** --------------------------------------------------------------------------*
$C$L42:    
;**	-----------------------g3:
;** 566	-----------------------    loc_nops();
;** 568	-----------------------    *_ret1 = 0u;
;** 573	-----------------------    return ret;
           CALL    .S1     _loc_nops         ; |566| 
           ADDKPC  .S2     $C$RL14,B3,4      ; |566| 
$C$RL14:   ; CALL OCCURS {_loc_nops} {0}     ; |566| 
;** --------------------------------------------------------------------------*

           MV      .L2     B11,B3            ; |574| 
||         STW     .D2T2   B5,*B10           ; |568| 

           RET     .S2     B3                ; |574| 
||         LDW     .D2T2   *+SP(12),B10      ; |574| 

           LDW     .D2T2   *++SP(16),B11     ; |574| 
           NOP             4
           ; BRANCH OCCURS {B3}              ; |574| 
;** --------------------------------------------------------------------------*
$C$L43:    
;**	-----------------------g4:
;** 573	-----------------------    return 1u;
           NOP             1
           ; BRANCH OCCURS {B3}              ; |574| 

;******************************************************************************
;* BUILD ATTRIBUTES                                                           *
;******************************************************************************
	.battr "TI", Tag_File, 1, Tag_ABI_stack_align_needed(0)
	.battr "TI", Tag_File, 1, Tag_ABI_stack_align_preserved(0)
	.battr "TI", Tag_File, 1, Tag_Tramps_Use_SOC(1)
